Bug 896087 - (prototype) Review Request: prototype - JavaScript framework
Review Request: prototype - JavaScript framework
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Adrien Devresse
Fedora Extras Quality Assurance
:
Depends On:
Blocks: Horde_Core
  Show dependency treegraph
 
Reported: 2013-01-16 10:08 EST by Remi Collet
Modified: 2013-07-21 14:36 EDT (History)
3 users (show)

See Also:
Fixed In Version: prototype-1.7.1.0-1.el6
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-07-15 21:32:01 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
adev88: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Remi Collet 2013-01-16 10:08:31 EST
Spec URL: https://raw.github.com/remicollet/remirepo/fb049802b5a6c045a0498ff77c5363b027c02e3d/prototype/prototype.spec
SRPM URL: http://rpms.famillecollet.com/SRPMS/prototype-1.7.1.0-1.remi.src.rpm
Description: 
Prototype is a JavaScript framework that aims to ease development of dynamic
web applications. It offers a familiar class-style OO framework, extensive
Ajax support, higher-order programming constructs, and easy DOM manipulation.

Fedora Account System Username: remi
Comment 1 Adrien Devresse 2013-07-03 11:36:06 EDT
I take this review.

Few comments :

- From my knowledges, the directory ownership of %{_datadir}/%{name} need to be specify explicitely

- Why not taking the source from the official github repo  ? 
https://github.com/sstephenson/prototype/releases
It include LICENSE file directly upstream  and unit tests.

- "prototype" is maybe just a bit generic for a name, Do you see any problem to name it something like prototypejs (which map the official website name) or prototype-javascript. 
Nothing is against this in the naming guidelines ( https://fedoraproject.org/wiki/Packaging:NamingGuidelines ), it's more a comment from my side.



Adrien
Comment 2 Remi Collet 2013-07-03 12:06:42 EDT
(In reply to Adrien Devresse from comment #1)
> I take this review.
> 
> Few comments :
> 
> - From my knowledges, the directory ownership of %{_datadir}/%{name} need to
> be specify explicitely

Hmm.. why ? It is correctly owned

> - Why not taking the source from the official github repo  ? 
> https://github.com/sstephenson/prototype/releases
> It include LICENSE file directly upstream  and unit tests.

As explain in the comments

# We cannot use the archive tarball from github
# as we don't have yet requirement for build (rake, sprockets or unusable version)

Notice : build is, in fact, only compression.
 
> - "prototype" is maybe just a bit generic for a name, Do you see any problem
> to name it something like prototypejs (which map the official website name)
> or prototype-javascript. 
> Nothing is against this in the naming guidelines (
> https://fedoraproject.org/wiki/Packaging:NamingGuidelines ), it's more a
> comment from my side.

I prefer to keep the upstream name (conflicts could also occurs in dir name, alias, ...).
Comment 3 Adrien Devresse 2013-07-03 12:35:01 EDT
>As explain in the comments

# We cannot use the archive tarball from github
# as we don't have yet requirement for build (rake, sprockets or unusable version)

Notice : build is, in fact, only compression.

Fine for me, it was jsut a suggestion. your link come from the official website anyway.


> I prefer to keep the upstream name (conflicts could also occurs in dir name, alias, ...).

Accepted.

> Hmm.. why ? It is correctly owned
I usually use the syntax "%dir %{_datadir}/%{name}" explicitely but your solution does not leave trash directory. Fine for me.


Anyway, it was just details. The package is globally really clean :)
Comment 4 Adrien Devresse 2013-07-03 12:36:18 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[X]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.

	-> MIT License

[-]: Package contains no bundled libraries without FPC exception.
	-> Pure JS

[X]: Changelog in prescribed format.
[X]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required
	-> Package designed to be EPEL 5 compliant

[X]: Sources contain only permissible code or content.
	-> Pure MIT
[X]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
	-> Package designed to be EPEL 5 compliant

[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[X]: Package requires other packages for directories it uses.

	-> Done for httpd

[-]: Package uses nothing in %doc for runtime.
[-]: Package is not known to require ExcludeArch.
[X]: Fully versioned dependency in subpackages, if present.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in prototype-
     httpd

	-> isa tag not required : noarch

[X]: Package complies to the Packaging Guidelines
[X]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. No licenses
     found. Please check the source files for licenses manually.

	-> MIT

[X]: License file installed when any subpackage combination is installed.
	-> all sub pkg depends on the main one.

[X]: Package consistently uses macro is (instead of hard-coded directory
     names).
[X]: Package is named according to the Package Naming Guidelines.

	-> cf comment

[-]: Package does not generate any conflict.
[X]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[X]: Package must own all directories that it creates.


[X]: Package does not own files or directories owned by other packages.
[X]: Requires correct, justified where necessary.
	-> Only httpd, justified for configuration files

[X]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.

	-> see Builds section	


[x]: %config files are marked noreplace or the reason is justified.
[-]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[!]: Buildroot is not present
     Note: Buildroot: present but not needed
	-> Package designed to be EPEL 5 compliant

[!]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: %clean present but not required

	-> Package designed to be EPEL 5 compliant

[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[!]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[-]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: prototype-1.7.1.0-1.el6.noarch.rpm
          prototype-httpd-1.7.1.0-1.el6.noarch.rpm
prototype-httpd.noarch: W: no-documentation
2 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint prototype-httpd prototype
prototype-httpd.noarch: I: enchant-dictionary-not-found en_US
prototype-httpd.noarch: W: no-documentation
2 packages and 0 specfiles checked; 0 errors, 1 warnings.
# echo 'rpmlint-done:'


Issues :
	No blocking issue

Comments :

buildroot clean/install:
		-> EPEL 5 compatible package : normal

%check is present and all tests pass.
		-> No unit tests, please include them if available in tarball in future.

No Documentation embeded 
		-> Impossible to build from tarball for now, if possible in future please do in order to add documentation and LICENSE

License Upstream 
		-> Same comment than previous one, clearly not critical.


Builds :

	Rawhide :

	http://koji.fedoraproject.org/koji/taskinfo?taskID=5569680

	EL 5:

	http://koji.fedoraproject.org/koji/taskinfo?taskID=5569814

	EL 6:

	http://koji.fedoraproject.org/koji/taskinfo?taskID=5569827

	
	F 19:

	http://koji.fedoraproject.org/koji/taskinfo?taskID=5569829
	
	F 18:

	http://koji.fedoraproject.org/koji/taskinfo?taskID=5569837



Package Accepted.
Comment 5 Remi Collet 2013-07-03 12:47:34 EDT
Thanks for the review.

New Package SCM Request
=======================
Package Name: prototype
Short Description: JavaScript framework
Owners: remi
Branches: f18 f19 el5 el6
InitialCC:
Comment 6 Gwyn Ciesla 2013-07-03 14:14:49 EDT
Git done (by process-git-requests).
Comment 7 Fedora Update System 2013-07-04 03:33:28 EDT
prototype-1.7.1.0-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/prototype-1.7.1.0-1.fc19
Comment 8 Fedora Update System 2013-07-04 03:33:42 EDT
prototype-1.7.1.0-1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/prototype-1.7.1.0-1.fc18
Comment 9 Fedora Update System 2013-07-04 03:33:52 EDT
prototype-1.7.1.0-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/prototype-1.7.1.0-1.el6
Comment 10 Fedora Update System 2013-07-04 03:34:04 EDT
prototype-1.7.1.0-1.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/prototype-1.7.1.0-1.el5
Comment 11 Michael Schwendt 2013-07-04 07:02:47 EDT
> - From my knowledges, the directory ownership of %{_datadir}/%{name}
> need to be specify explicitely

Depends. This page covers some of the problems related to incorrect directory ownership:

  https://fedoraproject.org/wiki/Packaging:UnownedDirectories

An entry in the %files section, such as

  %{_datadir}/%{name}

includes the path %{_datadir}/%{name}, if it is a _file_, and if it is a _directory_, it includes the directory with a proper %dir attribute *and* anything in that directory.

  %{_datadir}/%{name}
and
  %{_datadir}/%{name}/

achieve the same than

  %dir %{_datadir}/%{name}
  %{_datadir}/%{name}/*

Decide yourself when to be explicit about which files/dirs to include. Sometimes wildcards based on '*' are convenient, but spelling out individual file names can be beneficial (e.g. specific API header names or library versions).
Comment 12 Fedora Update System 2013-07-04 16:01:32 EDT
prototype-1.7.1.0-1.el6 has been pushed to the Fedora EPEL 6 testing repository.
Comment 13 Fedora Update System 2013-07-15 21:32:01 EDT
prototype-1.7.1.0-1.fc19 has been pushed to the Fedora 19 stable repository.
Comment 14 Fedora Update System 2013-07-15 21:33:15 EDT
prototype-1.7.1.0-1.fc18 has been pushed to the Fedora 18 stable repository.
Comment 15 Fedora Update System 2013-07-21 14:36:06 EDT
prototype-1.7.1.0-1.el5 has been pushed to the Fedora EPEL 5 stable repository.
Comment 16 Fedora Update System 2013-07-21 14:36:34 EDT
prototype-1.7.1.0-1.el6 has been pushed to the Fedora EPEL 6 stable repository.

Note You need to log in before you can comment on or make changes to this bug.